/*
##############################################
#         WebFX Dynamic Webboard 2.0         #
#       By Emil A Eklund (eae@eae.net)       #
#      and Erik Arvidson (erik@eae.net)      #
#           http://webfx.eae.net             #
#              April 13, 1999                #
##############################################
# Feel free to use this script for personal  #
# and non profit web sites, as long as you   #
# are giving us credits for it, in other     #
# words, not removing nor modifying this     #
# notice in any of the files it appears in   #
##############################################
#  For commercial use contact Emil or Erik   #
##############################################
*/

fixMessageViewerSize();
window.onload = initMessageViewerPrime;
window.onresize = fixMessageViewerSize;


function initMessageViewerPrime() {
	if (parent == null) return;
	parent.messageLoaded();
}

function fixMessageViewerSize() {
	var f = document.all.tags("IFRAME")[0];
	f.style.height = Math.max(document.body.clientHeight - f.offsetTop, 0);
}

function loadMessage(href, subject, from, email, date, groupName, ticksVal) {
	var f = document.frames[0];

	if (from != "" && email != "")
		document.all.email.innerHTML = "<a href=\"mailto:" + replaceSpecial(email) + "\" title=\"" + replaceSpecial(email) + "\">" + replaceSpecial(from) + "</a>";
	else if (from != "")
		document.all.email.innerText = from;
	else
		document.all.email.innerHTML = "&nbsp;";		

	if (date == "")
		document.all.date.innerHTML = "&nbsp;";
	else
		document.all.date.innerText = date;

	if (href == "")
		f.window.location = "about:blank";
	else
		f.window.location = href;

	
	var index = href.indexOf("id=");
	
	if (index != -1)
		id.value = href.substring(index+3, href.length)

	if (subject == "")
		document.all.subject.innerHTML = "&nbsp;";
	else
		document.all.subject.innerHTML = '<a href="' + cgiFile + '?action=display&group=' + groupName + '&id=' + id.value +
										 '" title="' + extLinkTitle + '"' +
										 " onclick='this.blur();alert(\"" + extLinkAlert + "\"); return false;'>"
										 + subject + '</a>';

	group.value = groupName;
	ticks.value = ticksVal;
	
	parent.messageLoaded();	// Notify the toolbar
	doMessageLoaded(href);
}

function doMessageLoaded(href) {
	var f = document.frames[0];
	if (f.document.readyState == "complete" && f.document.location == href)	{//In case the loading hasn't started yet
		var as = f.document.all.tags("A");

		for (var i=0; i<as.length; i++) {
			as[i].target = "_new";
		}
		
		var tt = parent.treeframe.document.all.messageTree.tree;
		if (tt == null)
			window.setTimeout("doMessageLoaded(\"" + href + "\")", 100);
			
		var cn = parent.treeframe.findNode(tt, href);
		
		if (cn != null) {
			window.clearTimeout(parent.treeframe.currentMessageTimer);
			parent.treeframe.currentMessageAnchorObject = cn.html.all.tags("A")[0];
			window.setTimeout("parent.treeframe.markAsRead()", parent.treeframe.timeBeforeRead);
		}
	}
	else {
		window.setTimeout("doMessageLoaded(\"" + href + "\")", 100);
	}	
}
